

# @promises/while-parallel
[![Source Code](https://img.shields.io/badge/%3C%2F%3E-source_code-blue.svg)](https://github.com/yisraelx/promises/blob/master/modules/while-parallel)
[![Version](https://img.shields.io/npm/v/@promises/while-parallel.svg)](https://www.npmjs.com/package/@promises/while-parallel)
[![MIT License](https://img.shields.io/npm/l/@promises/while-parallel.svg)](https://github.com/yisraelx/promises/blob/master/LICENSE)
[![Bundle Size](https://img.shields.io/bundlephobia/min/@promises/while-parallel.svg)](https://bundlephobia.com/result?p=@promises/while-parallel)

**While Parallel is package from Promises library**

## Use

**Module**
```sh
$ npm install --save @promises/while-parallel
```
```typescript
import {
 default as whileParallel
} from '@promises/while-parallel';
```

**Browser**
```html
<script src="https://unpkg.com/@promises/while-parallel/bundle.umd.min.js"></script>
```
```typescript
let {
 whileParallel
} = P;
```


**Examples**
```typescript
 let index: number = 0;

 whileParallel(() => {
  console.log(`test ${index}`);
  return index++ < 3;
 }, () => {
  let thisIndex = index;
  return timeout((resolve) => {
   console.log(`iteratee ${thisIndex}`);
   resolve();
  }, 4 - index);
 }).then(() => {
  console.log('completed');
 });

 // => 'test 0'
 // => 'test 1'
 // => 'test 2'
 // => 'test 3'
 // => 'iteratee 3'
 // => 'iteratee 2'
 // => 'iteratee 1'
 // => 'completed'
```



### Wrapper

**Module**
```sh
$ npm install --save @promises/while-parallel
```
```typescript
import Promises from '@promises/core';
import '@promises/while-parallel/add';
```
*Or*
```typescript
import Promises from '@promises/while-parallel/add';
```

**Browser**
```html
<script src="https://unpkg.com/@promises/core/bundle.umd.min.js"></script>
<script src="https://unpkg.com/@promises/while-parallel/add/bundle.umd.min.js"></script>
```
```typescript
let {
 Promises
} = P;
```


**Examples**
```typescript
let index: number = 0;
Promises.whileParallel(() => {
 console.log(`test ${index}`);
 return index++ < 3;
}, () => {
 let thisIndex = index;
 return Promises.timeout((resolve) => {
  console.log(`iteratee ${thisIndex}`);
  resolve();
 }, 4 - index);
}).then(() => {
 console.log('completed');
});
// => 'test 0'
// => 'test 1'
// => 'test 2'
// => 'test 3'
// => 'iteratee 3'
// => 'iteratee 2'
// => 'iteratee 1'
// => 'completed'
```


## Compatibility
These modules are written in typescript and available in ES5 and ES6 standard, the requirements are a global __Promise__ (native or polyfill).

## License
Copyright © 2017 [Yisrael Eliav](https://github.com/yisraelx),
Licensed under the [MIT license](https://github.com/yisraelx/promises/blob/master/LICENSE).
